'' +--------------------------------------------------------------------------+
'' | Cluso's Propeller Operating System - OS module: _DIR     --> _DIR.CMD    |
'' +--------------------------------------------------------------------------+
'' |  Authors:       (c)2011 by Kwabena W. Agyman (Kye) & J. Moxham (Dr_Acula)|
'' |  Modifications: (c)2012 "Cluso99" (Ray Rodrick)                          |
'' |  License:       MIT License - See end of file for terms of use           |
'' +--------------------------------------------------------------------------+
'' This OS module uses an included module to perform most of the housekeeping.
'' Each module is called from, and returns to, the prop binary "_CMD.CMD"
'' Compile with PropTool + "PreSpin 0.3" by Andy Schenk www.insonix.ch/propeller                             
'' Some OS modules are derived from: 
''      KyeDOS v3 (c) 2011 by Kwabena W. Agyman (Kye) & J. Moxham (Dr_Acula)
'' See the included code for history and acknowledgments.
''
'' RR20120317   This module does......

'#include "__MODULE.spin"        ' include the common code for OS modules 

DAT
_ModuleStr    byte      "=== DIR ===",0        'module's name (string)
 
PRI executeCommand(StringPointer) | buffer,counter,match

  ifnot(str.stringCompareCI(string("dir"), stringPointer))      '<-- module's name
    stringPointer := str.tokenizeString(0)              ' get the *.exe bit
    str.copy(stringpointer,@lineoftext1)                ' move to lineoftext1
    str.mid(@lineoftext1,@lineoftext2,str.instr(@lineoftext1,"."),4) ' get string from . to end = extension
    counter:=0
'   crlf
    fat.listEntries("W")   
    repeat while(buffer := fat.listEntries("N"))
      str.copy(buffer,@LineOfText1)                ' copy filename to LineOfText
      str.trimstring(@lineoftext1)
      str.mid(@lineoftext1,@lineoftext3,str.instr(@lineoftext1,"."),4) ' get string from . to end = extension     
      match := false                                    ' setup for below
      if str.len(@lineoftext2) == 0
        match := true                                   ' no extension so always print it
      else
        ifnot str.stringcompareci(@lineoftext2,@lineoftext3) ' reverse logic ?!
          match := true                                 ' found a match
      if match == true
        PrintString(@lineoftext1)                       ' print file name
        counter++                                       ' add one to counter
        repeat 13-str.len(@lineoftext1)                 ' add spaces so columns line up
            printchar(" ")                              ' print space
      if counter == 6                                   ' new line
        counter :=0
        crlf 
    crlf
    abort 0                                             ' so knows a command was run

dat                                                   
{{
+------------------------------------------------------------------------------------------------------------------------------+
|                                                   TERMS OF USE: MIT License                                                  |                                                            
+------------------------------------------------------------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    | 
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
+------------------------------------------------------------------------------------------------------------------------------+
}} 
